<?php
/**
 * Singelton class for admin panel
**/
class evAd {
    
    /**
     * Create main page for plugin
    **/
    public static function createMainPage() {
        if(!current_user_can('edit_posts')) {
            wp_die('No permissions!');
        }
        //When POST data presented, it means edited or newly created event to save
        if(isset($_POST) && !empty($_POST)) {
            //Save or update
            $res = evCore::saveEvent($_POST);
            if($res) {
                echo self::wrapStart('Event saved!','?page=eventist-main','Back to main page');
                echo self::showMessage('Your event is saved!','update');
                echo self::wrapEnd();
            } else {
                echo self::wrapStart('Event is NOT saved!','?page=eventist-main','Back to main page');
                echo self::showMessage('Your event is NOT  saved properly!');
                echo self::wrapEnd();
            }
            
        } else {
            //GET or simply main page
            if(self::getReqVars('action')) {
                //If we got ID too, it means editing
                if(self::getReqVars('id',1)) {
                    //Edit or delete existing event
                    if(self::getReqVars('action',1) == 'delete') {
                        //Delet an existing event
                        if(count(self::getReqVars('id',1)) > 1) {
                            //In this case we get a simple numeric array with ids
                            /**
                             * @todo when delet function return value added properly
                             * it has to be checked here! $res is here to do that
                            **/
                            $res = true;
                            $ev_to_del = self::getReqVars('id',1);
                            foreach($ev_to_del as $id) {
                                evCore::delEvent($id);
                            }
                            
                            $num = count(self::getReqVars('id',1));
                            echo self::wrapStart('Events deleted!','?page=eventist-main','Back to main page');
                            echo self::showMessage('Selected events('.$num.') are deleted from database!','update');
                            echo self::wrapEnd();
                            
                        } else {
                            $thisid = self::getReqVars('id',1);
                            evCore::delEvent($thisid[0]);
                            echo self::wrapStart('Event deleted!','?page=eventist-main','Back to main page');
                            echo self::showMessage('Selected event is deleted from database!','update');
                            echo self::wrapEnd();
                        }
                        
                        
                    } elseif(self::getReqVars('action',1) == 'cpy') {
                        //Copy an exsiting event
                        $res = evCore::copyEvent(self::getReqVars('id',1));
                        if($res) {
                            echo self::wrapStart('Event copied!','?page=eventist-main','Back to main page');
                            echo self::showMessage('You have copied an event successfully!','update');
                            echo self::wrapEnd();
                        } else {
                            echo self::wrapStart('Event NOT copied!','?page=eventist-main','Back to main page');
                            echo self::showMessage('Your event is NOT copied!!');
                            echo self::wrapEnd();
                        }
                    } elseif(self::getReqVars('action',1) == 'edit') {
                        //Edit an event
                        echo self::wrapStart('Edit existing event','?page=eventist-main','Back to main page');
                        self::getInputForm(evCore::getEvent($_GET['id']));
                        echo self::wrapEnd();
                    }
                } else {
                    //Add new event
                    echo self::wrapStart('Add a new event','?page=eventist-main','Back to main page');
                    self::getInputForm();
                    echo self::wrapEnd();
                }
            } else {
                //Simple main page
                echo self::wrapStart('List of events','?page=eventist-main&action=add','Add New');
                $p_opt = get_option(EVENTIST_OPT_PAGE);
                $msg_o_p = '
                Please set a page for events in Settings, otherwise Eventist
                 can not display event details properly.
                ';
                if(!isset($p_opt) || empty($p_opt)) echo self::showMessage($msg_o_p);
                $form = '<div id="ev_event_table">
                    <form method="get">
                    <input type="hidden" name="page" value="'.$_REQUEST['page'].'" />
                ';
                echo $form;
                //WP_List_Tables
                /**
                * List of displaying tables
                * @var array
                **/
                $disp = array(
                    'title' => 'Event Title',
                    'start_d' => 'Start Date',
                    'end_d' => 'End Date',
                    'location' => 'Location',
                    'details' => 'Details',
                    'evuser' => 'Created By',
                    'evdate' => 'Date Created'
                );
                /**
                * List of shortable column ids
                * @var array
                **/        
                $srt = array(
                    'evdate','start_d','end_d','title','location'
                );
                /**
                * List of hidden columnids
                * @var array
                **/        
                $hd = array(
                    'id','history'
                );
                //Create a new instance of our WP_List_Table implementation       
                $evtab = new evTable($disp,$srt,$hd);
                $evtab->prepare_items();
                $evtab->display();
                
                $form_end = '</form></div>';
                echo $form_end;
                echo self::wrapEnd();
            }
        }
        
    }
    
    /**
     * Create About page for plugin
    **/
    public static function createAboutSubPage() {
        echo self::wrapStart('About','?page=eventist-main','Back to events');
        
        $out = '
        <h3>What is Eventist Plugin?</h3>
        This plugin helps You to create and manage real life events on Your 
        WordPress blog. Allows You to display events on any sidebars of Your blog with 
        Eventist plugin own sidebar. In addition You can select a page of the blog
        to be the place to display event details. To do it, you don\'t need to use
        shortcodes in the content of the page, just lelect the page from the roll down menu in Settings.
        <br/>
        <h3>Eventist Sidebar</h3>
        To use eventist sidebar, go to Appearance/Widgets and drag Eventist Sidebar and activate it!
        On the option part you can choose two kind of display types for your events.
        Calendar type displays events inside a calendar table, the upcoming dsiplays events in
        a simple list. The length of the list is set by the user by the other input field below 
        the display type selector.<br/>
        <h3>Eventist event page</h3>
        Any of your page could be the placeholder for your events, and event details. 
        You can choose an arbitrary page form the blog pages on the setting panel of this plugin.
        (Eventist Plugin/Settings) Here, you can set the display type again, but now, it
        influences the appearance of the event page not the sidebar. However the options are same kind.
        <h3>Usage</h3>
        On Eventist main page you can see the ordered list of your events. The order can be changed
        by the little arrows near the column titles. The arrow direction shows the new order will be
        ascending or descending. You can add a new event by clicking <i>Add new</i> link.
        Every rows have 3 links in it. Edit, Copy and Delete. These are the available functions. You can edit an existing event or you can copy
        it, what means duplicate the same event with other ID. The last option is delet event.
        It could be done one-by-one by clicking the link int th row, or you can delete a 
        group of events by using the select this options from the selector at the top and the bottom of the events table.
        ';
        
        echo $out;
        
        echo self::wrapEnd();
    }
    
    /**
     * Create settings page
    **/
    public static function createSettingsPage() {
        
        if(self::getReqVars('eventistpage',1)) {
            //Saving options
            echo self::wrapStart('Settings saved','?page=eventist-settings','Back to settings');
            update_option(EVENTIST_OPT_PAGE,self::getReqVars('eventistpage',1));
            update_option(EVENTIST_DISP_TYPE,self::getReqVars('eventisttype',1));
            echo self::showMessage('Settings properly saved!','update');
        } else {
            //Print form
            echo self::wrapStart('General settings','?page=eventist-main','Back to events');
            $out = '
            <form method="post">
            <input type="hidden" name="page" value="'.$_REQUEST['page'].'" />
            <p>Eventist page:
                '.self::createSelectForPages().'<br/>
                <small>Select a single page to display event details and calendar</small></p>
                <p>
                Events display type:
                '.self::createSelectForDisplayType().'</br>
                <small>Select type of display. Calendar means table of calendar, list means a simple list of events</small>
                </p>
                <input type="submit" class="button-primary" id="submitbutton" />
            </form>
            ';
            echo $out;
            
        }
        echo self::wrapEnd();
    }
    
    /**
     * Get a post or get variable by given string identifier
     * @param string $id - the id
     * @param int $jmp - if 0, the result can be empty, but if 1 it has to be something
     * @return mixed
    **/
    public static function getReqVars($id,$jmp = 0) {
        $chk = true;
        if($jmp == 1 && (empty($_POST[$id]) && empty($_GET[$id]))) $chk = false;
        if(isset($_POST[$id]) && $chk) return $_POST[$id];
        if(isset($_GET[$id]) && $chk) return $_GET[$id];
        
        return false;
    }
    
    /**
     * Returns a htmlform, filled with content in case of event editing
     * and renders a wp built in editor
     * @return string
    **/
    private function getInputForm($ar=array()) {
        $e_set = array( 'media_buttons' => true,
		                          'wpautop' => false,
		                          'tinymce' => array( 'height' => '400',
		                                              'force_br_newlines' => false,
		                                              'force_p_newlines' => true,
		                                              'convert_newlines_to_brs' => false ),
		                          'quicktags' => true );
        ob_start();
            wp_editor($ar['details'],'details',$e_set);
            $ev_editor = ob_get_contents();
        ob_end_clean();
        
        $chk = '';
        if(evCore::isMultiday($ar['id'])) $chk = ' checked="checked"';
        
        $out = '
            <form method="post">
            <input type="hidden" name="id" value="'.$ar['id'].'" />
            <input type="hidden" name="saved" value="1" />
            <table class="eventist-evtable">
                <tr>
                    <th>Title:</th>
                    <td><input type="text" name="title" size="60" value="'.$ar['title'].'" /></td>
                </tr>
                
                <tr>
                    <th>Date(s):</th>
                    <td><input type="text" name="start_d" id="sd_id" size="20" value="'.$ar['start_d'].'" />
                    <input type="checkbox" name="notsameday" id="md_id" value="1"'.$chk.' />Multiday
                    <input type="text" name="end_d" id="ed_id" size="20" value="'.$ar['end_d'].'" />
                    </td>
                </tr>
                
                <tr>
                    <th>Location:</th>
                    <td><input type="text" name="location" size="60" value="'.$ar['location'].'" /></td>
                </tr>
                
                <tr>
                    <th>Time:</th>
                    <td><input type="text" name="time" size="60" value="'.$ar['time'].'" /></td>
                </tr>
                
                <tr>
                    <th>Details:</th>
                    <td>'.$ev_editor.'</td>
                </tr>
                <tr>
                    <th></th>
                    <td>
                        <input type="submit" class="button-primary" id="submitbutton" />
                    </td>
                </tr>
                
            </table>
            </form>
        ';
        
        echo $out;
    }
    
    /**
     * In this function I collected the begining html part of every plugin page
     * @param string $str - the title extension, subtitle
     * @param string $href - link for the upper link to point to
     * @param string $hfer_str - string for the link mentioned above
     * @return string
    **/
    private function wrapStart($str,$href,$href_str) {
        $upper = '<div class="wrap">';
        $upper .= '
        <div id="icon-edit" class="icon32"><br />
        </div><h2>Eventist - '.$str.'
        <a href="'.$href.'" class="add-new-h2">'.$href_str.'</a>
        </h2><br/>
        ';
        
        return $upper;
    }
    /**
     * Close the wrapStart's code properly
    **/
    private function wrapEnd() {
        return  '</div>';
    }
    
    /**
     * Showing messages
     * @param string $str - message
     * @param string $tp - type of message
     * @return string
    **/
    private function showMessage($str,$tp='error') {
        $htm = '';
        $type = $tp == 'error' ? 'error' : 'updated';
        $htm .= '<div id="message" class="'.$type.'"><p>'.$str.'</p></div>';
        
        return $htm;
    }
    
    /**
     * Get blog pages for settings
     * @return array
    **/
    public static function getBlogPages() {
        $pages = get_pages();
        $pdata = array();
        $db=0;
        foreach($pages as $page) {
            $pdata[$db]['ID'] = $page->ID;
            $pdata[$db]['title'] = $page->post_title;
            $db++;
        }
        
        return $pdata;
    }
    
    /**
     * Create select input field for page selection
     * @return string
    **/
    public static function createSelectForPages() {
        $pages = self::getBlogPages();
        $current_id = get_option(EVENTIST_OPT_PAGE);
        $out = '<select name="eventistpage" id="eventistpage">';
        foreach($pages as $page) {
            $chk = '';
            if($page['ID'] == $current_id) $chk = ' selected="selected"';
            $out .= '<option value="'.$page['ID'].'"'.$chk.'>'.$page['title'];
        }
        $out .= '</select>';
        
        return $out;
    }
    
    /**
     * Select fild to display what kind of display to use
    **/
    public static function createSelectForDisplayType() {
        $opts = array('Calendar','List');
        $current_type = get_option(EVENTIST_DISP_TYPE);
        $out = '<select name="eventisttype" id="eventisttype">';
        $db = 1;
        foreach($opts as $op) {
            $chk = '';
            if($db == $current_type) $chk = ' selected="selected"';
            $out .= '<option value="'.$db.'"'.$chk.'>'.$opts[$db-1];
            $db++;
        }
        $out .= '</select>';
        
        return $out;
    }
    
}

?>