<?php
/**
 * Eventist widget handling with class extends WP_Widget
**/

class evWid extends WP_Widget {
    //
    
    public $control_options = array(
        'title'=>'Eventist Widget',
        'dtypes'=>0,
        'dlimit'=>5
    );
    
    public function evWid() {
        parent::__construct(false,'Eventist Sidebar');
    }
    
    
    public function widget($args,$instance) {
        echo '
        <h3 class="widget-title">'.$instance['title'].'</h3>
        ';
        
        if($instance['dtypes'] == 1) {
            //Show only events limited by dlimit
            //It is always show events from the current month
            $events = evCore::getEventsByDate(array(date("Y"),date("m")));
            for($i=0;$i<(int)$instance['dlimit'];$i++) {
                if(empty($events[$i]['start_d'])) break;
                echo '
                <p><a href="?page_id='.get_option(EVENTIST_OPT_PAGE).'&eventistid='.$events[$i]['id'].'"><i>'.$events[$i]['start_d'].'</i></a>:<br/>
                <strong>'.$events[$i]['title'].'</strong></p>
                ';
            }
            echo '<p><a href="?page_id='.get_option(EVENTIST_OPT_PAGE).'">Events page</a></p>';
        } else {
            //Calendar
            $ec = new evCalendar(2012,12);
             echo $ec->display();
        }
    }
    
    public function update($new_instance,$old_instance) {
        $instance = $old_instance;
        $instance['title'] = $new_instance['title'];
        $instance['dtypes'] = $new_instance['dtypes'];
        $instance['dlimit'] = $new_instance['dlimit'];
        
        return $instance;
    }
    
    public function form($instance) {
        $myop = $this->getSelectedOpt($instance['dtypes']);
        $out = '
            <p>Title:<br/>
            <input type="text" name="'.$this->get_field_name('title').'" id="'.$this->get_field_id('title').'" value="'.$instance['title'].'" />
            <br/><small>Display widget title</small>
            </p>
            <p>
            Display type:<br/>
            <select name="'.$this->get_field_name('dtypes').'" id="'.$this->get_field_id('dtypes').'" >
                '.$myop.'
            </select><br/>
            <small>Select what type of display do you need</small>
            </p>
            <p>
            Upcomings limit:<br/>
            <input size="5" type="text" name="'.$this->get_field_name('dlimit').'" id="'.$this->get_field_id('dlimit').'" value="'.$instance['dlimit'].'" />
            <br/><small>If upcomings is selected, you can set limit of diplaying events</small>
            </p>
        ';
        echo $out;
    }
    
    private function getSelectedOpt($op_val) {
        $options = array(
            'Calendar','Upcomings'
        );
        
        for($i=0;$i<count($options);$i++) {
            $chk = '';
            if($op_val == $i) $chk = ' selected="selected"';
            $out .='<option value="'.$i.'"'.$chk.'>'.$options[$i];
        }
        
        return $out;
    }
    
}

?>